import { createAsyncThunk } from "@reduxjs/toolkit";
import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";

export const CreateTicketService = createAsyncThunk(
  "CREATE_TICKET",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());

    try {
      const { data, status } = await axios.post("ticket/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const CloseTicketService = createAsyncThunk(
  "CLOSE_TICKET",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    const { data, status } = await axios.put("ticket/0/", d);
    dispatch(LOADING_END());
    return { data, status };
  }
);

export const EditTicketService = createAsyncThunk(
  "EDIT_TICKET",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.put("ticket/0/", d);
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);
